
// Einfuehrung in Scilab/ScicosLab 
// ____________________________________
// Beispielskript 2: Skalare, Vektoren, Matrizen
// Matthias Kubisch, 02.04.2012


// Zuweisungen

    //  Skalare
    a = 2;
    b = a + a;
   
   
    // Vektoren
    x = [1,2,3];    // Zeilenvektor
    x = [1 2 3];    // (alternativ)
    
    y = [1;2;3];    // Spaltenvektor


    z = [1:10];     // alle Zahlen von 1 bis 10 als Vektor
    z = [1:2:10];   // unter Angabe des Inkrements 2


    // Matrizen
    A = [1 2 3;
         4 5 6;
         7 8 9];
         
    B = [A y];


    // eine Matrix umformen
    C = matrix(B, 2, 6);

    // einen Vektor bzw. eine Matrix transponieren

    x = y';
    
    C = B';
    
    
// Rechnen

    // Vektoren addieren/subtr. (Vektoren muessen gleiche Form haben)
    z = x + x;
    z = y - y; 
  
    // Vektoren multiplizieren
    
    // Skalarprodukt (Zeilenv. * Spaltenv.)
    a = x * y ;
    b = x * x';
    
    // Matrixprodukt (Spaltenv. * Zeilenvektor)
    a = y * x ;
    b = y * y';
    
    // Kreuzprodukt (s.u.)
    
    
    // elementweise Multiplikation/Division
    z = x .* x;
    z = x ./ x;
    
    
    
// Indizierung
    
    // Vektoren indizieren
    z = [1 2 3 4 5 6];
    
    f = z(4);
    f = z(1:3);
    f = z(4:$);
    
    // Matrizen indizieren
    A = [1 2 3; 
         4 5 6;
         7 8 9];
         
    B = A(:,1);     // erste Spalte 
    B = A(2,:);     // zweite Zeile
    
    B = A(1:2,1:2); // 2x2-Untermatrix oben links
    
    
    
    // Zufallszahlen, -vektoren, -matrizen
    a = rand();
    z = rand(1,10,"normal"); // Normalverteilter 10er Zeilenvektor (mean:0, var:1)
    C = rand(3,3,"uniform"); // Gleichverteilte 3x3-Matrix
    
    // Spezielle Matrizen
    C = zeros(3,3); // Matrix mit Nullen
    C = ones(3,3);  // Matrix mit Einsen
    E = eye(5,5);   // Einheitsmatrix 
    
    // Determinante
    d = det([1 2; 3 4]);
    
    // Inversion
    C = [2 2; -2 2];
    D = C * inv(C);
    
    
    // Vektoren und Matrizen (absteigend) sortieren
    
    z = rand(1, 10);
    z = sort(z);
    
    A = rand(3,3);
    B = sort(A);
    C = sort(A,'c'); // sortiert spaltenweise
    
    // Elemente suchen und finden
    w = find(z < 0.4); // alle Zahlen aus z die kleiner als 0,4 sind
    
    
//____

